source: BOL/script_install_amaury/install_lmdz.sh @ 4922

Last change on this file since 4922 was 4922, checked in by abarral, 3 weeks ago

merge rev 4877 & 4919 from trunk

  • Property svn:executable set to *
File size: 31.0 KB
Line 
1#!/bin/bash
2set -eu  # error on command failure, and on unset variables
3export LC_ALL=# standardize awk format
4
5###########################################################################
6# Author : Laurent Fairhead et Frédéric Hourdin
7# Usage  : install_lmdz.sh -help
8#
9# bash installation script of the LMDZ model on different computer types :
10# Linux PC, "mesocentre" (IPSL-UPMC, IPSL-X), super-computer (IDRIS)
11#
12# The model is downloaded in the following directory tree
13# $MODEL/modipsl/modeles/...
14# using the "modipsl" infrastructure created by the "IPSL"
15# for coupled (atmosphere/ocean/vegetation/chemistry) climate modeling
16# activities.
17# Here we only download atmospheric (LMDZ) and vegetation (ORCHIDEE)
18# components.
19#
20# The sources of the models can be found in the "modeles" directory.
21# In the present case, LMDZ, ORCHIDEE, and IOIPSL or XIOS (handling of
22# input-outputs using the NetCDF library).
23#
24# The script downloads various source files (including a version of NetCDF)
25# and utilities, compiles the model, and runs a test simulation in a
26# minimal configuration.
27#
28# Prerequisites : gfortran, bash or ksh, wget, gunzip, tar, ...
29#
30# Modif 18/11/2011
31#    changes for option real 8.
32#      We compile with -r8 (or equivalent) and -DNC_DOUBLE for the GCM
33#      but with -r4 for netcdf. Variable real must be set to
34#      r4 or r8 at the beginning of the script below.
35#
36###########################################################################
37
38### Functions
39
40function myget { # Get a file from LMDZ repository
41  local url=$1
42
43  local filename
44  filename=$(basename "$url")
45
46  wget --no-check-certificate -nv "http://lmdz.lmd.jussieu.fr/pub/$url"
47  if [[ $filename =~ .*\.(ba)?sh ]]; then chmod +x "$filename"; fi
48}
49
50function set_default_params {
51    # Valeur par défaut des parametres
52    svn_lmdz=""
53    version="20231022.trunk"
54
55    netcdf=1
56    bench=1
57    pcmac=0 # default: not on a Mac
58    SCM=0
59    veget="none"
60    grid_resolution="32x32x39"
61    physiq=""
62
63    xios_branch="2.6"
64    xios_rev="2568"
65
66    parallel="none"
67    trusting="testing"
68    MODEL=""
69
70    with_xios=0
71    opt_makelmdz_xios=""
72
73    rad="rrtm"
74
75    compile_with_fcm=1
76
77    cosp="none"
78    opt_cosp=""
79
80    make_j=8
81
82    # Check if on a Mac
83    if [[ $(uname) = "Darwin" ]]; then
84        pcmac=1
85        export MAKE="make"
86    fi
87
88    optim_debug=""
89    arch="local"
90
91    local mpi_file
92    mpi_file=$(readlink -f "$(which mpif90)")
93    path_mpi=$(dirname "$mpi_file")
94    root_mpi=$(dirname "$path_mpi")
95
96    arch="local-gfortran"
97    arch_dir=""
98}
99
100function read_cmdline_args {
101    while (($# > 0)); do
102        case $1 in
103            "-h") cat <<........fin
104        $0 [ -v version ] [ -r svn_release ]
105               [ -parallel PARA ] [ -d GRID_RESOLUTION ] [ -bench 0/1 ]
106               [-name LOCAL_MODEL_NAME] [-gprof] [-opt_makelmdz] [-rad RADIATIF]
107
108        -v       "version" like 20150828.trunk, see http://www.lmd.jussieu.fr/~lmdz/Distrib/LISMOI.trunk (default <$version>)
109
110        -r       "svn_release" : either the svn release number or "last" (default <$svn_lmdz>)
111
112        -parallel parallel support: mpi, omp, mpi_omp (mpi with openMP) or none (default: <$parallel>)
113
114        -d        "grid resolution": should be among the available benchs if -bench 1 (valid values: 48x36x19, 48x36x39) (default : <$grid_resolution>)
115
116        -bench     activating the bench or not (0/1) (default: <$bench>)
117
118        -testing/unstable
119
120        -name      name of the folder to install to (default <$MODEL>)
121
122        -netcdf    0, 1 or PATH. 0: do not download NetCDF, look for it in standard locations (/usr);  1: download and compile NetCDF; PATH: full path to an existing installed NetCDF library (default: <$netcdf>)
123
124        -xios      use (download and compile) the XIOS library (will compile the parallel NetCDF4-HDF5 library) (requires to also have -parallel mpi_omp)
125
126        -cosp       to run with cospv1 or cospv2 [none/v1/v2] (default <$cosp>)
127
128        -rad        radiative code: oldrad, rrtm or ecrad (default <$rad>)
129
130        -nofcm      to compile without fcm
131
132        -SCM        install 1D version automatically
133
134        -debug      compile everything in debug mode
135
136        -physiq     to choose which physics package to use (default <$physiq>)
137
138        -veget      surface/vegetation scheme treatment controlled by the single variable veget which can have the following values: none: bucket scheme (default); CMIP6 | veget2.0: orchidee version used in CMIP exercise, rev 5661; veget2.2: orchidee branch 2.2, rev 8529 (bundled); number: orchidee version number (default $veget)
139
140        -arch       name of the arch to use (default <$arch>)
141
142        -arch_dir   where to find the arch files (default <$arch_dir>)
143
144        -make_j     number of processes to parallelize installations (default <$make_j>)
145
146........fin
147                  exit 1;;
148            "-v") version=$2; shift; shift;;
149            "-r") svn_lmdz=$2; shift; shift;;
150            "-d") grid_resolution=$2; shift; shift;;
151            "-unstable"|"-testing") trusting=$(echo "$1" | cut -c2-); shift;;
152            "-cosp") cosp=$2
153                     case $cosp in
154                         "none"|"v1"|"v2") cosp=$2; shift; shift;;
155                         *) echo "Only none v1 v2 for cosp option"; exit 1
156                     esac;;
157            "-nofcm") compile_with_fcm=0; echo "This option will be reactivated soon (promesse du 8dec2022)"; exit 1;  shift;;
158            "-SCM") SCM=1; shift;;
159            "-rad") rad=$2
160                    case $rad in
161                        "oldrad"|"rrtm"|"ecrad") rad=$2; shift; shift;;
162                        *) echo "Only oldrad rrtm ecrad for rad option"; exit 1
163                    esac;;
164            "-parallel") parallel=$2
165                         case $parallel in
166                             "none"|"mpi"|"omp"|"mpi_omp") parallel=$2; shift; shift;;
167                             *) echo "Only none mpi omp mpi_omp for the parallel option"; exit 1
168                         esac;;
169            "-bench") bench=$2; shift; shift;;
170            "-debug") optim_debug=-debug; shift;;
171            "-name") MODEL=$2; shift; shift;;
172            "-netcdf") netcdf=$2; shift; shift;;
173            "-physiq") physiq=$2; shift; shift;;
174            "-xios") with_xios=1; shift;;
175            "-arch") arch=$2; shift; shift;;
176            "-arch_dir") arch_dir=$2; shift; shift;;
177            "-veget") veget=$2; shift; shift;;
178            "-make_j") make_j=$2; shift; shift;;
179            *)  bash install_lmdz.sh -h; exit 1
180        esac
181    done
182
183    # Option de compilation pour Cosp
184    case $cosp in
185        v1) opt_cosp="-cosp true";;
186        v2) opt_cosp="-cospv2 true";;
187        *) opt_cosp=""
188    esac
189
190    # Check on veget version
191    if [[ $veget != 'none' && $veget != "CMIP6" && $veget != "orch2.0" && $veget != "orch2.2" ]]; then
192        re='^[0-9]+$'
193        if ! [[ $veget =~ $re ]]; then
194            echo 'Valeur de l option veget non valable'; exit 1
195        fi
196    fi
197
198    #Define veget-related suffix for gcm name
199    if [[ $veget = 'none' ]]; then
200        suff_orc=''
201    else
202        suff_orc='_orch'
203    fi
204
205
206    if [[ $parallel = "none" ]]; then
207        suff_exe='_seq'
208    else
209        suff_exe='_para_mem'
210    fi
211
212    #Chemin pour placer le modele
213    if [[ $MODEL = "" ]]; then MODEL="./LMDZ$version$svn_lmdz$optim_debug"; fi
214
215    ## if also compiling XIOS, parallel must be mpi_omp
216    if [[ $with_xios = 1 && $parallel != "mpi_omp" ]]; then
217        echo "Error, you must set -parallel mpi_omp if you want XIOS"; exit 1
218    fi
219
220    if [[ $with_xios = 1 ]]; then
221        opt_makelmdz_xios="-io xios"
222    fi
223
224    if [[ $cosp = "v2" && $with_xios = 0 ]]; then
225        echo "Error, Cospv2 cannot run without Xios"; exit 1
226    fi
227
228    if [[ $arch_dir = "" ]]; then
229        arch_dir="$MODEL/modipsl/config/IPSLCM7/ARCH/"
230    fi
231    arch_dir=$(readlink -f "$arch_dir")  # full path
232}
233
234function check_available_software {
235    echo "################################################################"
236    echo "Check if required software is available"
237    echo "################################################################"
238    for logiciel in wget tar gzip make gcc cmake m4 c++; do
239        if [[ $(which "$logiciel") = "" ]]; then
240            echo "You must first install $logiciel on your system"; exit 1
241        fi
242    done
243
244    cat <<eod > tt.f90
245print*,'coucou'
246end
247eod
248    $compiler tt.f90 || a.out
249    ./a.out >| tt
250    if [[ $(< tt sed -e 's/ //g' ) != "coucou" ]]; then
251        echo "problem installing with compiler $compiler"; exit 1
252    fi
253    \rm tt a.out tt.f90
254}
255
256function download_model {
257    mkdir -p "$MODEL"
258    MODEL=$(readlink -f "$MODEL"); echo "$MODEL"  # absolute path
259
260    rm -rf "$MODEL/modipsl"
261
262    echo "##########################################################"
263    echo "Download a slightly modified version of  LMDZ"
264    echo "##########################################################"
265    cd "$MODEL"
266    getlog="$(pwd)/get.log"
267    echo "logfile : $getlog"
268    myget "src_archives/$trusting/modipsl.$version.tar.gz" >> get.log 2>&1
269    echo "install_lmdz.sh wget_OK $(date)"
270    gunzip "modipsl.$version.tar.gz" >> get.log 2>&1
271    tar xf "modipsl.$version.tar" >> get.log 2>&1
272    \rm "modipsl.$version.tar"
273}
274
275function create_model_tar {  # TODO TEMP while waiting for tar: we copy the base from a local path = IPSLCM7 + ORCH2.2 8504
276    if [[ ! -d ../MODEL_REF ]]; then
277        cd ..
278        mkdir MODEL_REF
279        cd MODEL_REF
280        # Base is IPSLCM7
281        svn co --username icmc_users https://forge.ipsl.fr/igcmg/svn/modipsl/trunk modipsl
282        cd modipsl/util
283        ./model IPSLCM7_work
284        # Remove unused components
285        rm -rf ../oasis3-mct
286        cd ../modeles
287        rm -rf ICOSA_LMDZ ORCHIDEE_4 ORCHIDEE_2_2 NEMO DYNAMICO XIOS INCA
288        # Retrieve orch version
289        svn co svn://forge.ipsl.fr/orchidee/branches/ORCHIDEE_2_2/ORCHIDEE -r 8504
290        # Correct orchidee bug in 8504
291        sed -i"" -e "s/ts.second=dt_routing/ts%second=dt_routing/" -e "380,390 s/USE grid/USE grid, temp_disabled => contfrac/" ORCHIDEE/src_sechiba/routing_native_flow.f90
292
293        cd ../../../script_install
294    fi
295
296    if [[ ! -d "$MODEL" ]]; then
297        \cp -r ../MODEL_REF .
298        mv MODEL_REF "$MODEL"
299    fi
300    MODEL=$(readlink -f "$MODEL"); echo "$MODEL"  # absolute path
301}
302
303function init_arch {
304    if [[ ! -d $arch_dir ]]; then
305        echo "Error: no arch dir $arch_dir"; exit 1
306    elif [[ ! -f $arch_dir/arch-$arch.path ]]; then
307        echo "Error: no arch-$arch.path in $arch_dir"; exit 1
308    fi
309
310    local fcm_path
311    if [[ -f $arch_dir/arch-$arch.fcm ]]; then
312        fcm_path="$arch_dir/arch-$arch.fcm"
313    else
314        fcm_path="$MODEL/modipsl/modeles/LMDZ/arch/arch-$arch.fcm"
315        if [[ ! -f $fcm_path ]]; then
316            echo "Error: no $fcm_path"; exit 1
317        fi
318    fi
319
320    # check compiler
321    compiler=$(< "$fcm_path" grep "%COMPILER" | sed -e "s/%COMPILER\s*//")
322
323    # load env
324    local env_path=${fcm_path/.fcm/.env}
325    # shellcheck disable=SC1090
326    if [[ -f $env_path ]]; then source "$env_path"; fi
327}
328
329function install_arch {
330    local component=$1
331
332    if [[ ! -f "$MODEL/modipsl/modeles/$component/arch/arch-$arch.fcm" ]]; then
333        \cp -f "$arch_dir/arch-$arch.fcm" "$MODEL/modipsl/modeles/$component/arch"
334        \cp -f "$arch_dir/arch-$arch.path" "$MODEL/modipsl/modeles/$component/arch"
335
336        if [[ $component = "XIOS" ]]; then
337            # Adapt for XIOS, which uses different naming conventions
338            sed -i'' -e "s/%COMPILER/%FCOMPILER/" -e "s/%LINK/%LINKER/" -e "s/-fdefault-real-8//" "$MODEL/modipsl/modeles/XIOS/arch/arch-$arch.fcm"
339        elif [[ $component = "ORCHIDEE" ]]; then
340            if [[ $orcbranch = "/tags/ORCHIDEE_2_0/ORCHIDEE" ]]; then  # 2.0 and before have a different fcm convention
341                sed -i'' -e "s/-I//" -e "s/-L//" "$MODEL/modipsl/modeles/ORCHIDEE/arch/arch-$arch.path"  # /!\ we only replace first occurence on purpose
342            fi
343        fi
344    fi
345}
346
347function install_netcdf {
348    echo "Installing Netcdf"
349    local ncdf_compiler="$compiler"
350
351    if [[ $netcdf = 0 ]]; then
352        ncdfdir=$(nc-config --prefix)
353    else
354        cd "$MODEL"
355
356        # Convert non-basic compiler
357        case $compiler in
358            mpif90) ncdf_compiler=$($compiler --version | head -n 1 | cut -d " " -f -1)
359        esac
360
361        case $ncdf_compiler in
362            gfortran | GNU) ncdf_compiler="gfortran"; opt1="-compiler gnu"; opt2="-CC gcc -FC gfortran -CXX g++";;
363            *)      echo "unexpected compiler $ncdf_compiler for netcdf"; exit 1
364        esac
365
366        case $with_xios in
367            0) script_install_netcdf="install_netcdf4_hdf5_seq.bash"
368               ncdfdir="netcdf4_hdf5_seq"
369               opt_="$opt1";;
370            1) script_install_netcdf="install_netcdf4_hdf5.bash"
371               ncdfdir="netcdf4_hdf5"
372               opt_="$opt2 -MPI $root_mpi";;
373            *) echo "with_xios=$with_xios, should be 0 or 1"; exit 1
374        esac
375        if [[ $netcdf = 1 ]]; then
376           ncdfdir="$MODEL/$ncdfdir"
377        else
378           mkdir -p "$netcdf"; ncdfdir="$netcdf/$ncdfdir"
379        fi
380
381        echo "Repertoire netcdf $ncdfdir"
382        if [[ ! -d $ncdfdir ]]; then
383            netcdflog=$(pwd)/netcdf.log
384            echo "----------------------------------------------------------"
385            echo "Compiling the Netcdf library"
386            echo "----------------------------------------------------------"
387            echo "log file : $netcdflog"
388            myget script_install/$script_install_netcdf >> "$netcdflog" 2>&1
389            chmod u=rwx $script_install_netcdf
390            # shellcheck disable=SC2086
391            ./$script_install_netcdf -prefix "$ncdfdir" $opt_ >> "$netcdflog" 2>&1
392        fi
393
394        # Add to path
395        export PATH="$ncdfdir/bin:$PATH"
396
397        #----------------------------------------------------------------------------
398        # LF rajout d'une verrue, pour une raison non encore expliquee,
399        # la librairie est parfois rangée dans lib64 et non dans lib
400        # par certains compilateurs
401        if [[ ! -e lib && -d lib64 ]]; then ln -s lib64 lib; fi
402        #----------------------------------------------------------------------------
403
404        echo "install_lmdz.sh netcdf_OK $(date)"
405    fi
406
407    cat >test_netcdf90.f90 <<EOF
408    use netcdf
409    print *, "NetCDF library version: ", nf90_inq_libvers()
410    end
411EOF
412
413    if $ncdf_compiler -I"$ncdfdir"/include test_netcdf90.f90 -L"$ncdfdir"/lib -lnetcdff \
414              -lnetcdf -Wl,-rpath="$ncdfdir"/lib && ./a.out
415    then
416        \rm test_netcdf90.f90 a.out
417    else
418        cat <<EOF
419Failed test program using NetCDF-Fortran. You can:
420- check that you have NetCDF-Fortran installed in your system
421- or specify an installation directory with option -netcdf of install_lmdz.sh
422- or download and compile NetCDF-Fortran with option -netcdf 1 of nstall_lmdz.sh
423EOF
424        exit 1
425    fi
426
427    # Compile NetCDF95
428    cd "$MODEL/modipsl/modeles/LMD"*
429    echo "Installing NetCDF95"
430    cd "$MODEL"
431    myget src_archives/netcdf/NetCDF95-0.3.tar.gz
432    tar -xf NetCDF95-0.3.tar.gz
433    \rm NetCDF95-0.3.tar.gz
434    cd NetCDF95-0.3
435    mkdir -p build && cd build
436    netCDF_INCLUDE_DIR=$(nc-config --includedir) netCDF_LIBRARY=$(nc-config --libdir) cmake .. -DCMAKE_BUILD_TYPE=Release -DCMAKE_PREFIX_PATH="$ncdfdir" -DCMAKE_INSTALL_PREFIX="$MODEL/modipsl"
437    make install
438}
439
440function install_IOIPSL {
441    install_arch "IOIPSL"
442
443    cd "$MODEL/modipsl/modeles/IOIPSL"
444    ioipsllog="$(pwd)/ioipsl.log"
445    echo "Compiling IOIPSL, the interface library with Netcdf $(date) (log: $ioipsllog)"
446
447    if ! ./makeioipsl_fcm -arch "$arch" -job 8 > "$ioipsllog" 2>&1; then
448        echo "IOIPSL compile failed, exiting"; exit 1
449    fi
450
451    # Link to modipsl/bin
452    cp -f bin/* ../../bin
453
454    echo "IOIPSL compiled $(date)"
455
456    IOIPSL_LIBDIR_="$MODEL/modipsl/modeles/IOIPSL/lib"
457    IOIPSL_INCDIR_="$MODEL/modipsl/modeles/IOIPSL/inc"
458}
459
460function install_XIOS {
461    if [[ $with_xios = 1 ]]; then
462        cd "$MODEL/modipsl/modeles"
463        xioslog="$(pwd)/XIOS/xios.log"
464        echo "##########################################################"
465        echo "Compiling XIOS (log $xioslog) $(date)"
466        echo "##########################################################"
467
468        # Download XIOS
469        case $xios_branch in
470            "trunk")
471            xios_http="http://forge.ipsl.fr/ioserver/svn/XIOS/trunk";;
472            "2.5")
473            xios_http="http://forge.ipsl.fr/ioserver/svn/XIOS2/branches/xios-2.5";;
474            "2.6")
475            xios_http="http://forge.ipsl.fr/ioserver/svn/XIOS2/branches/xios-2.6";;
476            *) echo "XIOS: Error, bad argument for -branch ! Did not expect $xios_branch"; exit 1;;
477        esac
478       
479        cd "$MODEL/modipsl/modeles"
480        set +e; svn co --revision $xios_rev $xios_http XIOS; set -e
481
482        cd XIOS
483
484        install_arch "XIOS"
485
486        echo "Starting XIOS compilation"
487        if ! ./make_xios --arch "$arch" --job 8 > "$xioslog" 2>&1; then
488            echo "XIOS compilation failed, exiting"; exit 1
489        fi
490
491        echo "Compiled XIOS $(date)"
492    fi
493
494    XIOS_LIBDIR_="$MODEL/modipsl/modeles/XIOS/lib"
495    XIOS_INCDIR_="$MODEL/modipsl/modeles/XIOS/inc"
496}
497
498function get_orchidee_version {  # Set / Check ORCHIDEE version
499    local fetch_rev=""
500    orcbranch=""
501    case $veget in
502        "none") fcm_veget_version="false";;
503        "orch2.0" | "CMIP6") fcm_veget_version=orchidee2.0; fetch_rev=7906;;  # in previous tar we used 6592 but with some modifications to xios_orchidee.f90, which got integrated in 7906
504        "orch2.2") fcm_veget_version=orchidee2.1; orcbranch="ORCHIDEE_2_2" ;; # the bundled version
505        *) fetch_rev=$veget
506    esac
507
508    if [[ -n $fetch_rev ]]; then
509        echo "Fetching orch $fetch_rev from the repository"
510        orcbranch=$(svn log -v -q svn://forge.ipsl.fr/orchidee/ -r "$fetch_rev" | grep ORCHIDEE | head -1 | sed -e 's:ORCHIDEE/.*$:ORCHIDEE:' | awk '{print $2}')
511        echo "branch is $orcbranch"
512        if [[ $fetch_rev -lt 4465 ]]; then echo 'ORCHIDEE version must be >=4465, exiting'; exit 1; fi
513        \rm -rf "$MODEL/modipsl/modeles/ORCHIDEE"
514        echo "IF YOU INSTALL ORCHIDEE THE VERY FIRST TIME, ASK for PASSWORD at orchidee-help@listes.ipsl.fr"
515        cd "$MODEL/modipsl/modeles"
516        set +e
517        svn co -r "$fetch_rev" "svn://forge.ipsl.fr/orchidee/$orcbranch"
518        set -e
519        cd -
520    fi
521
522
523    # Check parallel LMDZ+ORCH
524    if [[ (! $veget = "none") && $parallel = "none" && ($used_lmdz_rev -lt 4894) ]]; then
525        echo "LMDZ revision must be >=4894 for orchidee without parallel support. Upgrade lmdz or use -parallel mpi_omp."; exit 1
526    fi
527}
528
529function compile_orchidee {
530    install_arch "ORCHIDEE"
531
532    if [[ $veget != "none" ]]; then
533        cd "$MODEL/modipsl/modeles/ORCHIDEE"
534
535        orchideelog="$(pwd)/orchidee.log"
536        echo "Compiling ORCHIDEE, the continental surface model (log $orchideelog) $(date)"
537
538        local xios_orchid opt_orc
539        if [[ $with_xios = 1 ]]; then
540            xios_orchid="-xios";
541        else
542            xios_orchid="-noxios"
543        fi
544        if [[ $optim_debug = "-debug" ]]; then
545            opt_orc="-debug";
546        else
547            opt_orc="-prod"
548        fi
549
550        local varenv="IOIPSL_LIBDIR_=$IOIPSL_LIBDIR_ IOIPSL_INCDIR_=$IOIPSL_INCDIR_ XIOS_INCDIR_=$XIOS_INCDIR_ XIOS_LIBDIR_=$XIOS_LIBDIR_"
551        if [[ $parallel = "none" ]]; then
552            echo "$varenv ./makeorchidee_fcm $xios_orchid $opt_orc -parallel none -arch $arch -j $make_j" > compile.sh
553        else
554            if [[ ! -d src_parallel ]]; then
555               echo "Orchidee version too old for parallel support"; exit 1
556            fi
557            {
558                echo "$varenv ./makeorchidee_fcm -j $make_j $xios_orchid $opt_orc -parallel $parallel -arch $arch"
559            } > compile.sh
560        fi
561        chmod +x compile.sh
562        echo "Compiling ORCHIDEE using $(\cat compile.sh)"
563        if ! ./compile.sh > "$orchideelog" 2>&1; then
564            echo "ORCHIDEE compilation failed, exiting"; exit 1
565        fi
566        echo "Compiled ORCHIDEE $(date)"
567    fi
568
569    ORCH_INCDIR_="$MODEL/modipsl/modeles/ORCHIDEE/inc"
570    ORCH_LIBDIR_="$MODEL/modipsl/modeles/ORCHIDEE/lib"
571}
572
573function get_lmdz_version {
574    LMDZPATH=$(readlink -f "$MODEL/modipsl/modeles/LMD"*)
575    cd "$LMDZPATH"
576    lmdzlog="$(pwd)/lmdz.log"
577
578    used_lmdz_rev=$svn_lmdz
579    if [[ -n $svn_lmdz ]]; then
580        local lmdzbranch
581        echo "Fetching LMDZ $svn_lmdz from the repository"
582        lmdzbranch=$(svn log -v -q https://svn.lmd.jussieu.fr/LMDZ -r "$svn_lmdz" | grep LMDZ | head -1 | sed -e 's:trunk/.*$:trunk:' | awk '{print $2}')
583        \rm -rf "$MODEL/modipsl/modeles/LMDZ"
584        cd "$MODEL/modipsl/modeles"
585        set +e
586        svn co -r "$svn_lmdz" "https://svn.lmd.jussieu.fr/LMDZ$lmdzbranch" LMDZ
587        set -e
588        cd -
589    else  # get svn from info
590         used_lmdz_rev=$(svn info | grep "Last Changed Rev" | cut -c 19-)
591    fi
592}
593
594function compile_lmdz {
595    install_arch "LMDZ"
596    cd "$LMDZPATH"
597
598    exe_name="bin/gcm_${grid_resolution}_phylmd_${rad}${suff_exe}${suff_orc}.e"
599
600    local opt_rad
601    case $rad in
602        oldrad) iflag_rrtm=0; NSW=2; opt_rad="";;
603        rrtm)   iflag_rrtm=1; NSW=6
604            if [[ $used_lmdz_rev -le 4185 ]]; then
605                opt_rad="-rrtm true"
606            else
607                opt_rad="-rad rrtm"
608            fi;;
609        ecrad)  iflag_rrtm=2; NSW=6; opt_rad="-rad ecrad";;
610        *) echo "Only oldrad rrtm ecrad for rad option"; exit 1
611    esac
612    if [[ $used_lmdz_rev -le 4185 && $rad = "ecrad" ]]; then
613        echo "ecrad only available for LMDZ rev starting with 4186 "; exit 1
614    fi
615
616    # Compile
617    local varenv="IOIPSL_LIBDIR_=\"$IOIPSL_LIBDIR_\" IOIPSL_INCDIR_=\"$IOIPSL_INCDIR_\" ORCH_INCDIR_=\"$ORCH_INCDIR_\" ORCH_LIBDIR_=\"$ORCH_LIBDIR_\" XIOS_INCDIR_=\"$XIOS_INCDIR_\" XIOS_LIBDIR_=\"$XIOS_LIBDIR_\""
618    makelmdz="makelmdz_fcm $optim_debug -arch $arch -j $make_j"
619    if [[ $parallel = "none" ]]; then
620        echo "$varenv ./$makelmdz $opt_rad $opt_cosp -d ${grid_resolution} -v $fcm_veget_version gcm " > compile.sh
621    else
622        echo "$varenv ./$makelmdz $opt_rad $opt_cosp $opt_makelmdz_xios -d ${grid_resolution} -v $fcm_veget_version -mem -parallel $parallel gcm" > compile.sh
623    fi
624    echo "Compiling lmdz using $(\cat compile.sh) (log: $lmdzlog) $(date)"
625    chmod +x ./compile.sh
626    if ! ./compile.sh > "$lmdzlog" 2>&1; then
627        echo "LMDZ compilation failed, exiting"; exit 1
628    fi
629    echo "Finished LMDZ compilation $(date)"
630
631    # Check executable
632    # TODO $mysev -ge 4186 => other name convention ! check original install
633    if [[ ! -f $exe_name ]]; then
634        echo "Compilation failed, can't find the executable"; exit 1
635    else
636        echo "Compilation successfull, the executable is $exe_name $(date)"
637    fi
638}
639
640function run_bench {
641    cd "$MODEL/modipsl/modeles/LMDZ"*
642
643    if [[ $bench = "tuto" ]]; then
644        myget "Training/tutorial.tar"; tar xf tutorial.tar; cd TUTORIAL
645        ./init.sh
646    elif [[ $bench = 1 ]]; then
647        \rm -rf "BENCH${grid_resolution}"
648        local bench=bench_lmdz_${grid_resolution}
649        myget "3DBenchs/$bench.tar.gz"
650        tar xf "$bench.tar.gz"
651
652        if [[ $cosp = "v1" || $cosp = "v2" ]]; then
653            cd "BENCH${grid_resolution}"
654            # copier les fichiers namelist input et output our COSP
655            cp ../DefLists/cosp*_input_nl.txt .
656            cp ../DefLists/cosp*_output_nl.txt .
657            # Activer la cles ok_cosp pour tourner avec COSP
658            sed -e 's@ok_cosp=n@ok_cosp=y@' config.def > tmp
659            \mv -f tmp config.def
660            cd ..
661        fi
662
663        if [[ -n "$physiq" ]]; then
664            cd "BENCH${grid_resolution}"
665            if [[ -f "physiq.def_${physiq}" ]]; then
666                cp "physiq.def_${physiq}" physiq.def
667                echo "using physiq.def_${physiq}"
668            else
669                echo "using standard physiq.def"
670            fi
671            cd ..
672        else
673            echo "using standard physiq.def"
674        fi
675
676        if [[ $with_xios = 1 ]]; then
677            cd "BENCH${grid_resolution}"
678            cp ../DefLists/iodef.xml .
679            cp ../DefLists/context_lmdz.xml .
680            cp ../DefLists/field_def_lmdz.xml .
681            # A raffiner par la suite
682            echo "A FAIRE : Copier les *xml en fonction de l option cosp"
683            cp ../DefLists/field_def_cosp*.xml .
684            cp ../DefLists/file_def_hist*xml .
685            # adapt iodef.xml to use attached mode
686            sed -e 's@"using_server" type="bool">true@"using_server" type="bool">false@' \
687                iodef.xml > tmp
688            \mv -f tmp iodef.xml
689
690            # and convert all the enabled="_AUTO_" (for libIGCM) to enabled=.FALSE.
691            # except for histday
692            for histfile in file_def_hist*xml
693            do
694                if [[ "$histfile" = "file_def_histday_lmdz.xml" ]]; then
695                    sed -e 's@enabled="_AUTO_"@type="one_file" enabled=".TRUE."@' \
696                        "$histfile" > tmp
697                    \mv -f tmp "$histfile"
698                    sed -e 's@output_level="_AUTO_"@output_level="5"@' "$histfile" \
699                        > tmp
700                    \mv -f tmp "$histfile"
701                    sed -e 's@compression_level="2"@compression_level="0"@' \
702                        "$histfile" > tmp
703                    \mv -f tmp "$histfile"
704                else
705                    sed -e 's@enabled="_AUTO_"@type="one_file" enabled=".FALSE."@' \
706                        "$histfile" > tmp
707                    \mv -f tmp "$histfile"
708                fi
709            done
710            # and add option "ok_all_xml=y" in config.def
711            echo "### XIOS outputs" >> config.def
712            echo 'ok_all_xml=.true.' >> config.def
713
714            #activer les sorties pour Cosp
715            if [[ "$cosp" = "v1" ]]; then
716                sed -i'' -e 's@enabled=".FALSE."@enabled=".TRUE."@' \
717                         -e 's@output_level="_AUTO_"@output_level="5"@' \
718                         -e 's@compression_level="2"@compression_level="0"@' \
719                         file_def_histdayCOSP_lmdz.xml
720            fi
721            if [[ "$cosp" = "v2" ]]; then
722                sed -e 's@compression_level="2"@compression_level="0"@' file_def_histdayCOSPv2_lmdz.xml
723                for type_ in hf day mth; do
724                    file=file_def_hist${type_}COSP
725                    sed -i'' -e 's@src="./'${file}'_lmdz.xml"@src="./'${file}'v2_lmdz.xml"@' context_lmdz.xml
726                done
727                sed -i '' -e 's@field_def_cosp1.xml@field_def_cospv2.xml@' field_def_lmdz.xml
728            fi
729
730            cd ..
731        fi
732
733        # Cas Bench avec ecrad
734        if [[ $rad = "ecrad" ]]; then
735            cd "BENCH${grid_resolution}"
736            cp  ../DefLists/namelist_ecrad .
737            cp -r ../libf/phylmd/ecrad/data .
738            cd ..
739        fi
740
741        # Adjusting bench physiq.def to radiative code chosen
742        cd "BENCH${grid_resolution}"
743        sed -e 's/iflag_rrtm=.*.$/iflag_rrtm='$iflag_rrtm'/' \
744            -e 's/NSW=.*.$/NSW='$NSW'/' physiq.def > tmpdef
745        \mv tmpdef physiq.def
746        cd ..
747
748        cp "$exe_name" "BENCH${grid_resolution}/gcm.e"
749        cd "BENCH${grid_resolution}"
750
751        if [[ ${parallel:0:3} = "mpi" ]]; then
752            # Lancement avec deux procs mpi et 2 openMP
753            echo "export OMP_STACKSIZE=800M" > bench.sh
754            if [[ "${parallel:4:3}" = "omp" ]]; then
755                echo "export OMP_NUM_THREADS=2" >> bench.sh
756            fi
757            if [[ "$cosp" = "v1" || "$cosp" = "v2" ]]; then
758                echo "ulimit -s 200000" >> bench.sh
759            else
760                echo "ulimit -s unlimited" >> bench.sh
761            fi
762            echo "mpirun -np 2 gcm.e > listing  2>&1" >> bench.sh
763            # Add rebuild, using reb.sh if it is there
764            cat <<EOF >> bench.sh
765    if [[ -f reb.sh ]]; then
766      ./reb.sh histday; ./reb.sh histmth; ./reb.sh histhf;
767      ./reb.sh histins; ./reb.sh stomate_history;
768      ./reb.sh sechiba_history; ./reb.sh sechiba_out_2
769    fi
770EOF
771        else
772            echo "./gcm.e > listing  2>&1" > bench.sh
773        fi
774        # Getting orchidee stuff
775        if [[ $veget = 'CMIP6' || $veget = "orch2.0" ]]; then  # TODO once we have a 2.2 bench, add it here (or in planned separate bench script)
776            echo 'myget 3DBenchs/BENCHCMIP6.tar.gz'
777            myget 3DBenchs/BENCHCMIP6.tar.gz
778            tar xvzf BENCHCMIP6.tar.gz
779            sed -e "s:VEGET=n:VEGET=y:" config.def > tmp
780            mv -f tmp config.def
781            if [[ $with_xios = 1 ]]; then
782                cp ../../ORCHIDEE/src_xml/context_orchidee.xml .
783                echo '<context id="orchidee" src="./context_orchidee.xml"/>' > add.tmp
784                cp ../../ORCHIDEE/src_xml/field_def_orchidee.xml .
785                cp ../../ORCHIDEE/src_xml/file_def_orchidee.xml .
786                cp ../../ORCHIDEE/src_xml/file_def_input_orchidee.xml .
787                if [[ -f ../../ORCHIDEE/src_xml/context_input_orchidee.xml ]]; then
788                       cp ../../ORCHIDEE/src_xml/context_input_orchidee.xml .
789                       echo '<context id="orchidee" src="./context_input_orchidee.xml"/>' >> add.tmp
790                fi
791                sed -e '/id="LMDZ"/r add.tmp' iodef.xml > tmp
792                mv tmp iodef.xml
793                sed -e'{/sechiba1/ s/enabled="_AUTO_"/type="one_file" enabled=".TRUE."/}' \
794                    file_def_orchidee.xml > tmp
795                \mv -f tmp file_def_orchidee.xml
796                sed -e 's@enabled="_AUTO_"@type="one_file" enabled=".FALSE."@' \
797                    file_def_orchidee.xml > tmp
798                \mv -f tmp file_def_orchidee.xml
799                sed -e 's@output_level="_AUTO_"@output_level="1"@' \
800                    file_def_orchidee.xml > tmp
801                \mv -f tmp file_def_orchidee.xml
802                sed -e 's@output_freq="_AUTO_"@output_freq="1d"@' \
803                    file_def_orchidee.xml > tmp
804                \mv -f tmp file_def_orchidee.xml
805                sed -e 's@compression_level="4"@compression_level="0"@' \
806                    file_def_orchidee.xml > tmp
807                \mv -f tmp file_def_orchidee.xml
808                sed -e 's@XIOS_ORCHIDEE_OK = n@XIOS_ORCHIDEE_OK = y@' \
809                    orchidee.def > tmp
810                \mv -f tmp orchidee.def
811            fi
812        fi
813
814        if [[ -f ../arch.env ]]; then source ../arch.env; fi
815
816        echo "EXECUTION DU BENCH"
817        date
818        if (! ./bench.sh > out.bench 2>&1) || ! (tail -n 1 listing | grep "Everything is cool"); then
819            tail listing
820            echo "Bench FAILED, exiting"; exit 1
821        fi
822        date
823        tail listing
824    fi
825
826    # 1D case
827    if [[ $SCM = 1 ]]; then
828        cd "$MODEL"
829        myget 1D/1D.tar.gz
830        tar xf 1D.tar.gz
831        cd 1D
832        if [[ $rad = "oldrad" ]]; then
833            sed -i'' -e 's/^rad=.*$/rad=oldrad/' run.sh
834            sed -i'' -e 's/^rad=.*$/rad=oldrad/' bin/compile
835        elif [[ $rad = ecrad ]] ; then
836                        sed -i'' -e 's/^rad=.*$/rad=ecrad/' run.sh
837                        sed -i'' -e 's/^rad=.*$/rad=ecrad/' bin/compile
838                    fi
839        echo "Running 1D/run.sh, log in $(pwd)/run1d.log"
840        ./run.sh > "$(pwd)/run1d.log" 2>&1
841    fi
842}
843
844echo "install_lmdz.sh DEBUT $(date)"
845
846set_default_params
847read_cmdline_args "$@"
848#download_model
849create_model_tar
850init_arch
851check_available_software
852get_lmdz_version
853get_orchidee_version
854install_netcdf
855install_IOIPSL
856install_XIOS
857compile_orchidee
858compile_lmdz
859run_bench
Note: See TracBrowser for help on using the repository browser.